/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;

public class Frame2 extends Frame
{
	public Frame2()
	{
		setLayout(null);
		setSize(430,270);
		setTitle("Untitled");

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
	}

	public Frame2(String title)
	{
		this();
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new Frame2()).setVisible(true);
	}

	public void addNotify()
	{
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	//}}


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Frame2.this)
				Frame1_WindowClosing(event);
		}
	}

	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}
}
